# @scalify/shared-microservice

A scalable and modular shared lib for building microservices using **TypeScript** and **Node.js**. This project provides a solid foundation for creating high-quality, maintainable, and production-ready microservices.  

---

## Documentation and Architecture Details

For those who want a deeper understanding of the platform, including its architecture or CI/CD workflows, comprehensive documentation is available in the `/docs` folder. This documentation provides detailed insights and examples for implementation and scalability, inspired by the principles used in [Scalify E-Commerce Docs](https://github.com/scalify-xyz/docs).


## Installation  

### 1. Clone the Repository  

Download the boilerplate to your local machine:  

```bash  
git clone https://github.com/username/boilerplate-microservice.git  
cd boilerplate-microservice  
```  

### 2. Setup Husky  

This boilerplate comes with **Husky** pre-configured to enforce Git hooks, ensuring consistent code quality before commits:  

```bash  
npm run prepare  
```  

### 3. Install Dependencies  

Install the required Node.js packages:  

```bash  
npm install  
```  

## Run the Service  

Start the microservice in development mode:  

```bash  
npm run start:dev  
```  

## License  

This project is licensed under the [MIT License](LICENSE).  
